<h1>Users</h1>
<!--DIRECTIVES
ngIf = creates conditionals in our template(s)
ngFor = used to loop through an array

* ADDING LOGIC INTO OUR TEMPLATE
** Every structural directive NEEDS to have the asterisk (*)
-->
<!--<h3>{{ users[0].firstName }}</h3>-->
<!--<h3>{{ users[1].firstName }}</h3>-->

<!--Adding keyboard input events-->
<button (click)="showUserForm = !showUserForm" class="btn btn-dark mb-3">Add User</button>
<div class="card card-body mb-3" *ngIf="showUserForm">
  <h2>Add User</h2>
  <form #userForm="ngForm" (ngSubmit)="onSubmit(userForm)">
    <div class="form-group">
      <label>First Name</label>
      <input
        type="text"
        [(ngModel)]="user.firstName"
        class="form-control is-invalid"
        name="firstName"
        #userFirstName="ngModel"
        required
        minlength="2"
      >
<!--  Submit name required  -->
      <div [hidden]="!userFirstName.errors?.required" class="invalid-feedback">First Name Required</div>
    </div>
  <div class="form-group">
      <label>Last Name</label>
      <input type="text"  [(ngModel)]="user.lastName" class="form-control" name="lastName">
    </div>

    <div class="form-group">
      <label>Age</label>
      <input type="text" [(ngModel)]="user.age" class="form-control" name="age">
    </div>

    <div class="form-group">
      <label>Email</label>
      <input
        type="email" [(ngModel)]="user.email"
        [ngClass]="{'is-invalid': userEmail.errors && userEmail.touched}"
        class="form-control"
        [(ngModel)]="user.email"
        name="Email"
        #userEmail="ngModel"
        required
        pattern="[a-z0-9!#$%&'*+/=?^_`{|}~-]+(?:\.[a-z0-9!#$%&'*+/=?^_`{|}~-]+)*@(?:[a-z0-9](?:[a-z0-9-]*[a-z0-9])?\.)+[a-z0-9](?:[a-z0-9-]*[a-z0-9])?">

    <div [hidden]="!userEmail.errors?.required" class="invalid-feedback">
      Email name required
    </div>

    <div [hidden]="!userEmail.errors?.required" class="invalid-feedback">
        Email is not valid!
    </div>
  </div>

      <button [disabled]="userForm.form.valid" class="btn btn-block mb-3">Add New User</button>
  </form>
</div>
<!--    Adding event to button (click)-->
<!--<button (click)="addUser(user)" [disabled]="user.firstName == '' || user.lastName == ''"  class="btn-light btn-block mb-3" [ngClass]="currentClass">Add New Users</button>-->
<!--    Other examples for event -->
<!--<button (mousedown)="fireEvent($event)" [disabled]="!enableAddUser" class="btn-light btn-block mb-3" [ngClass]="currentClass">Add New Users</button>-->
<!--<button (dragover)="fireEvent($event)" [disabled]="!enableAddUser" class="btn-light btn-block mb-3" [ngClass]="currentClass">Add New Users</button>-->
<div>
  <ul class="list-unstyled" *ngIf="users.length> 0">
<!--    CLASS BINDING- add or use certain classes depending on certain properties, values, or aspect of a component-->
    <li class="card card-body mb-2" *ngFor="let user of users" [class.bg-primary]="user.isActive">
      <div class="row">
        <div class="col-sm-4">
<!--   BIND OUR IMAGE PROPERTY -->
          <img class="img-fluid" [src]="user.image" alt="">
<!--   OTHER WAYS OF BINDING OUR IMAGE-->
<!--          <img class="img-fluid" src="{{ user.image }}" alt="">-->
<!--          <img class="img-fluid" bind-src="user.image" alt="">-->
        </div>
        <div class="col-sm-8">
<!--    ngStyle]-->
<!--    If user has age and address fire off click event-->
          <h2 [ngStyle]="currentStyle" >{{user.firstName}} {{user.lastName}}<button
            (click)="toggleHide(user)" class="btn btn-dark btn-sm"><i [ngClass]="user.hide ? 'fa fa-plus': 'fa fa-minus'"></i>hide or show</button></h2>
          <ul *ngIf="user.age && user.email">
            <li>Age: {{ user.age }}</li>
            <li>Email: {{ user.email}} </li>
<!--    Angular Pipes- a way to format our data in our template-->
<!--            <li class="list-group-item"> Balance: {{ user.balance | currency }}</li>-->
<!--            <li class="list-group-item"> Balance: {{ user.balance | currency : "USD": " " }}</li>-->
<!--    EXAMPLE FOR DATE PIPE-->
<!--            <li class="list-group-item">-->
<!--              {{ user.memberSince | date }}-->
<!--              {{ user.memberSince | date: "MM/dd/yyyy" }}-->
<!--              {{ user.memberSince | date: "yyyy/MM/dd" }}-->
<!--              {{ user.memberSince | date: "fullDate" }}-->
<!--            </li>-->
<!--    EXAMPLE FOR NUMBER PIPE-->
<!--            <li class="list-group-item">-->
<!--              {{ 5 | number: "2.4" }}-->
<!--            </li>-->
<!--     EXAMPLE FOR PERCENT PIPE-->
<!--            <li class="list-group-item">-->
<!--              {{ 1 | percent }} -->
<!--              <pre ngNonBindable> {{ .5 | percent }} </pre>-->
<!--              {{ .5 | percent }}-->
<!--            </li>-->
<!--    ngNonBindable - makes an element (s) disabled to binding data-->
<!--            <li class="list-group-item" ngNonBindable>-->
<!--              {{ .5 | percent }}-->
<!--            </li>-->
          </ul>
        </div>
      </div>
    </li>
  </ul>
<h3 *ngIf="users.length === 0">No Users Found</h3>
<!--<h3 *ngIf="">Loading Users...</h3>-->
</div>
